"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var fs = require("fs-extra");
var path = require("path");
var child_process_1 = require("child_process");
var utils_1 = require("./utils");
var create_1 = require("./create");
var modify_1 = require("./modify");
var delete_1 = require("./delete");
var createClient = require('contentful-management').createClient;
function Run(args) {
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        var _a, from, to, fromTypes, toTypes, HEADER, FOOTER, runner, promises;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, loadSources(args)];
                case 1:
                    _a = _b.sent(), from = _a[0], to = _a[1];
                    fromTypes = utils_1.indexById(from);
                    toTypes = utils_1.indexById(to);
                    HEADER = "import Migration from 'contentful-migration-cli'\n\n// Generated by contentful-schema-diff\n// from " + args.from + "\n// to   " + args.to + "\nexport = function (migration: Migration) {\n";
                    FOOTER = "\n}\n";
                    runner = args.oneFile ?
                        new WriteSingleFileRunner(args.outDir, HEADER, FOOTER) :
                        new FilePerContentTypeRunner(args.outDir, HEADER, FOOTER);
                    return [4 /*yield*/, runner.init()];
                case 2:
                    _b.sent();
                    promises = runner.run(Object.keys(toTypes), function (id, chunkWriter) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (!fromTypes[id]) return [3 /*break*/, 2];
                                    return [4 /*yield*/, modify_1.writeModify(fromTypes[id], toTypes[id], chunkWriter)];
                                case 1:
                                    _a.sent();
                                    return [3 /*break*/, 4];
                                case 2: return [4 /*yield*/, create_1.writeCreate(toTypes[id], chunkWriter)];
                                case 3:
                                    _a.sent();
                                    _a.label = 4;
                                case 4: return [2 /*return*/];
                            }
                        });
                    }); });
                    promises.push.apply(promises, runner.run(Object.keys(fromTypes), function (id, chunkWriter) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            if (toTypes[id]) {
                                // handled above in 'writeModify'
                                return [2 /*return*/];
                            }
                            delete_1.writeDelete(id, chunkWriter);
                            return [2 /*return*/];
                        });
                    }); }));
                    return [4 /*yield*/, Promise.all(promises)];
                case 3:
                    _b.sent();
                    return [4 /*yield*/, runner.close()];
                case 4:
                    _b.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports["default"] = Run;
var WriteSingleFileRunner = /** @class */ (function () {
    function WriteSingleFileRunner(outDir, header, footer) {
        this.fileName = path.join(outDir, new Date().toISOString().replace(/[^\d]/g, '').substring(0, 14) + "_generated_from_diff.ts");
        this.outputStream = fs.createWriteStream(this.fileName);
        this.fileWriter = utils_1.asyncWriter(this.outputStream);
        this.header = header;
        this.footer = footer;
    }
    WriteSingleFileRunner.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.fileWriter(this.header)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    WriteSingleFileRunner.prototype.run = function (keys, run) {
        var _this = this;
        return keys.map(function (id) { return __awaiter(_this, void 0, void 0, function () {
            var chunks, header;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        chunks = [];
                        return [4 /*yield*/, run(id, function (chunk) { return Promise.resolve(chunks.push(chunk)); })];
                    case 1:
                        _a.sent();
                        if (!(chunks.length > 0)) return [3 /*break*/, 3];
                        header = "\n  /************  " + id + "  ******************/\n";
                        return [4 /*yield*/, this.fileWriter(header + chunks.join(''))];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        }); });
    };
    WriteSingleFileRunner.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.fileWriter(this.footer)];
                    case 1:
                        _a.sent();
                        this.outputStream.close();
                        return [4 /*yield*/, utils_1.wait(1)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, formatFile(this.fileName)];
                    case 3:
                        _a.sent();
                        console.log('wrote file', this.fileName);
                        return [2 /*return*/];
                }
            });
        });
    };
    return WriteSingleFileRunner;
}());
var FilePerContentTypeRunner = /** @class */ (function () {
    function FilePerContentTypeRunner(outDir, header, footer) {
        this.streams = [];
        this.outDir = outDir;
        this.header = header;
        this.footer = footer;
    }
    FilePerContentTypeRunner.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/];
            });
        });
    };
    FilePerContentTypeRunner.prototype.run = function (keys, run) {
        var _this = this;
        return keys.map(function (id) { return __awaiter(_this, void 0, void 0, function () {
            var writer;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        writer = this.makeWriter(id);
                        return [4 /*yield*/, run(id, writer)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
    };
    FilePerContentTypeRunner.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                this.streams.map(function (tuple) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, tuple.writer(this.footer)];
                            case 1:
                                _a.sent();
                                tuple.stream.close();
                                return [4 /*yield*/, utils_1.wait(1)];
                            case 2:
                                _a.sent();
                                return [4 /*yield*/, formatFile(tuple.fileName)];
                            case 3:
                                _a.sent();
                                console.log('wrote file', tuple.fileName);
                                return [2 /*return*/];
                        }
                    });
                }); });
                return [2 /*return*/];
            });
        });
    };
    FilePerContentTypeRunner.prototype.makeWriter = function (id) {
        var _this = this;
        var stream = undefined;
        var writer;
        var fileName;
        return function (chunk) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!!stream) return [3 /*break*/, 2];
                        fileName = path.join(this.outDir, new Date().toISOString().replace(/[^\d]/g, '').substring(0, 14) + "_generated_diff_" + id.underscore() + ".ts");
                        stream = fs.createWriteStream(fileName);
                        writer = utils_1.asyncWriter(stream);
                        this.streams.push({ stream: stream, writer: writer, fileName: fileName });
                        return [4 /*yield*/, writer(this.header)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        writer(chunk);
                        return [2 /*return*/];
                }
            });
        }); };
    };
    return FilePerContentTypeRunner;
}());
function formatFile(file) {
    var tsFmtBinLocation = path.join(require.resolve('typescript-formatter'), '../../.bin/tsfmt');
    var tsfmtConfigFile = path.relative(process.cwd(), path.join(__dirname, '../tsfmt.json'));
    return new Promise(function (resolve, reject) {
        child_process_1.exec(tsFmtBinLocation + " -r " + file + " --useTsfmt " + tsfmtConfigFile, function (err, stdout, stderr) {
            if (err) {
                reject(err.message + '\n\t' + stderr);
            }
            else {
                resolve();
            }
        });
    });
}
function loadSources(args) {
    return Promise.all([
        loadSource(args.from, args),
        loadSource(args.to, args)
    ]);
}
function loadSource(source, args) {
    return __awaiter(this, void 0, void 0, function () {
        var contents, client, space, types;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fs.pathExists(source)];
                case 1:
                    if (!_a.sent()) return [3 /*break*/, 3];
                    return [4 /*yield*/, fs.readFile(source)];
                case 2:
                    contents = _a.sent();
                    return [2 /*return*/, JSON.parse(contents.toString()).contentTypes];
                case 3:
                    // get from space
                    if (!args.managementToken) {
                        throw new Error(source + " is not a file and I don't have a management token to talk to contentful.");
                    }
                    client = createClient({
                        accessToken: args.managementToken
                    });
                    return [4 /*yield*/, client.getSpace(source)];
                case 4:
                    space = _a.sent();
                    return [4 /*yield*/, space.getContentTypes()];
                case 5:
                    types = _a.sent();
                    return [2 /*return*/, types.toPlainObject().items];
            }
        });
    });
}
